---
---  \file wrap_iarray1.lua
---  \brief Lua  wrapper for 1D itype Arrays
--- 
--- Various constructors are defined.
---
--- \todo Hartmuts Arrays, dann dokumentieren.
--
-- List of column resp. row arrays
--
--- \luaonly Construct 1D double array from constructor table.
--- 
--+ Array * IArray1(table desc);
--- 
--- 
function IArray1(desc)
	      local v
           if not desc then 
	    return nil

           -- desc is a array1 already created
	   elseif istype(desc,"IArray1") then
              return desc

	    -- desc is presumeable a Lua array:
	    -- copy its values into array1
	    elseif table.getn(desc) >0 and desc[table.getn(desc)] then
	       v=mbase.ia1Create(table.getn(desc))
	       for i=1,table.getn(desc) do 
		  mbase.ia1Set(v,i,desc[i])
	       end
             -- If length is given, create uninitialized
	     -- array1
	     elseif desc.n then
		v=mbase.ia1Create(desc.n)
		-- Initialization info given
		if desc.init then
		   -- constant initializer:
		   if type(desc.init)=="number" then
		      for i=1,desc.n do v[i]=desc.init end -- better use vSet
		   -- function initializer
 		   elseif type(desc.init)=="function" then
		      for i=1,desc.n do v[i]=desc.init(i) end
		   end
		end
	     elseif desc.array then
		if desc.row then
		   v=mbase.ia2Row(desc.array,desc.row)
		elseif desc.col then
		   v=mbase.ia2Col(desc.array,desc.col)
		else
		   v=mbase.ia2All(desc.array)
		end
		-- no information given: create an adjusteable array1
	     else
		v=mbase.ia1Create(0)
	     end
	     return v
end

if not _array1 then _array1={} end
_array1["int"]=IArray1


