help=[[
         Vector viewer for pdelib2.
Usage:
   
   [pdelib2] vfview2 [inputfile [assignments|switches] ]

Input:
   
   inputfile must be .vec
   

COMMAND LINE SWITCHES

   -h      This help.
   -test   Generates test data on nodes from grid coordinates.
           Inputfile must be one of .grid, .xgrid, .ele, .sg, .psg, .lua
   
]]


processargs(arg)

inputfile=arg.files[1]

if arg.switches.h then print(help) return end
if not inputfile then print(help) return end

glv2SetStateFile(filePrefFile("vfview2.ini"))


function load_grid(fname)
  local grid=gRead(fname)
  if not grid then error("Unable to read "..fname) end
  if not istype(grid,"Grid") then error("No Grid "..fname) end
  gPrintStatus(grid)
  return grid
end


if arg.switches.test then
  
  viewer=glv2Create(10,10,"vfview2 - test data on nodes",true)
  
  grid=load_grid(inputfile)
  
  space=gsCreateFV(grid,gNode);
  u = da2CreateS(space,gSpaceDim(grid));
  vcopy(gCoord(grid),u)
  
  vf2View(viewer,u)
  glv2Run()
  
else
  
  viewer=glv2Create(10,10,"vfview2",true)
  
  vf2View(viewer,inputfile)
  glv2Run()

end





